## Script (Python) "cpsdocument_edit"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: student_edit.py 486 2006-09-06 10:09:39Z joachim $
"""
return Info about the current Student
"""
#from Products.ZCTextIndex.QueryParser import ParseError,QueryError
request = context.REQUEST
form = request.form
fget = form.get
info = {}
wf = context.portal_workflow
catalog = context.portal_catalog
student_wf_states = wf.waeup_student_wf.states.keys()
info['wf_states'] = student_wf_states
info['wf_states'][0] = " ----- "
mtool = context.portal_membership
member = mtool.getAuthenticatedMember()
lt = context.portal_layouts
pr = context.portal_registration
path_info = request.get('PATH_INFO').split('/')
roles = member.getRoles()
is_manager = 'Manager' in roles or 'SectionManager' in roles
validate = request.has_key("cpsdocument_edit_button")
items = []
default = {'search_mode': 'name', 
        'review_state': 'admission_applied ', 
        'search_string': ''
        }
        
rend,psm,ds = lt.renderLayout(layout_id= 'student_search',
                      schema_id= 'student_search',
                      context=context,
                      mapping=validate and request,
                      ob=default,
                      layout_mode='edit',
                      formaction="searchStudents"
                      )
if psm == '':
    return context.students_manager_view(rendered = rend,
                             psm = psm,
                             #psm = "%s, %s" % (psm,ds),
                             students = items,
                             is_manager = is_manager,
                             )
what = ds.get('search_mode')
state = ds.get('review_state')
term = ds.get('search_string')
err = False
with_review = state != "all"
if not term and not with_review:
    psm = "You must specify a search string when searching in 'All States'"
    err = True
elif '*' in term:
    psm = "you cannot use the '*' alone"
    err = True
if err: 
    return context.students_manager_view(rendered = rend,
                             psm = psm,
                             #psm = "%s, %s" % (psm,ds),
                             students = items,
                             is_manager = is_manager,
                             )
with_review = state != "all"
items = []
res = []
portal_type_query = {'query':['Student','StudentApplication','StudentPersonal']}
st_queries = ('jamb_id','matric_no','name')
onlyreview = with_review and not term
if onlyreview:
    res = catalog(portal_type=portal_type_query,
                  review_state=state)
elif what == "student_id":
    if with_review:
        res = catalog(portal_type='Student',
                      id = term.strip(),
                      review_state=state)
    else:
        res = catalog(portal_type='Student',
                      id = term.strip())
elif what in st_queries: 
    if what == "jamb_id":
        pt = 'StudentApplication'
        st = "%s*" % term.strip().lower()
    elif what == "matric_no":
        pt = 'StudentClearance'
        st = "%s*" % term.strip().lower()
    elif what == "name":
        pt = portal_type_query
        st = "%s*" % term.strip()
    if with_review:
        try:
            res = catalog(portal_type=pt,SearchableText=st,
                          review_state=state)
        except:
            return context.students_manager_view(rendered = rend,
                                 psm = 'Searchstring "%s" not allowed' % term,
                                 #psm = "%s, %s" % (psm,ds),
                                 students = items,
                                 is_manager = is_manager,
                                 )
    else:
        try:
            res = catalog(portal_type=pt,SearchableText=st,)
        except:
            return context.students_manager_view(rendered = rend,
                                 psm = 'Searchstring "%s" not allowed' % term,
                                 #psm = "%s, %s" % (psm,ds),
                                 students = items,
                                 is_manager = is_manager,
                                 )
            
if res:
    for r in res:
        if r.portal_type in ("StudentApplication","StudentPersonal"):
            student = r.getObject().aq_parent
        else:
            student = r.getObject()
        if student not in items:
            items.append(student)
students = []
if items:
    for item in items:
        students.append(context.getStudentInfo(item))
return context.students_manager_view(rendered = rend,
                             psm = "%d matching Students found" % len(items),
                             #psm = "%s, %s" % (psm,ds),
                             students = students,
                             is_manager = is_manager,
                             )
